#include <iostream.h>
#include "tcp_connection.H"
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/time.h>
#include <stdio.h>

#define TCP_VERSION "0.04 alpha nofrag++"

char *TCP_Sender::version(){
  return TCP_VERSION;
}

TCP_Sender::TCP_Sender(char *t, unsigned short tp, char *source, unsigned short sp)
{
  cout << "[tcp_sender] Version " << TCP_VERSION << endl;
  
  output_interval=5;
  bandwidth=0;
  last_call=gettimeasdouble();

  if(source){
    src_host=strdup(source);
    src_port=sp;
  } 
  else {
    src_host=NULL;
    src_port=0;
  }

  to_host=strdup(t);  
  to_port=tp;
  
  to_hent=gethostbyname(to_host);
  if(to_hent==NULL) {
    perror("[tcp_sender] gethostbyname");
    return;
  }
  
    
  memset(&to_addr,0,sizeof(to_addr));
  memcpy(&to_addr.sin_addr, to_hent->h_addr, to_hent->h_length);
  to_addr.sin_port=htons(to_port);
  to_addr.sin_family=AF_INET;
    
  sock=socket(AF_INET, SOCK_STREAM,0);
  if(sock==-1) {
    perror("[tcp_sender] socket");
    return;
  }
    
  struct linger ling;
  ling.l_onoff=1;
  ling.l_linger=0;
  setsockopt(sock, SOL_SOCKET, SO_LINGER, &ling, sizeof(ling));

  if(src_host){
    cout << "[tcp_sender] setting src address" << endl;
    src_hent=gethostbyname(src_host);
    if(src_hent==NULL) {
      perror("[tcp_sender] gethostbuname");
      return;
    }
    memset(&src_addr,0,sizeof(src_addr));
    memcpy(&src_addr.sin_addr, src_hent->h_addr, src_hent->h_length);
    src_addr.sin_port=htons(src_port);
    src_addr.sin_family=AF_INET;
    if(bind(sock, (struct sockaddr*) &src_addr,sizeof(src_addr))!=0) {
      perror("[tcp_sender] bind");
      return;
    }
  }
  
  if(connect(sock, (struct sockaddr*) &to_addr, sizeof(to_addr))!=0) {
    perror("[tcp_sender] connect");
    return;
  }
}


int TCP_Sender::sendbuff(char *b, unsigned long l) {
  int k=0;
  
  k=sendto(sock, b, l, 0, (struct sockaddr*)&to_addr, sizeof(to_addr));
  
  if(output_interval)
    {
      amount+=l;
      double t1=gettimeasdouble();
      if(t1-last_call > output_interval) {
	bandwidth=8.0*amount/(t1-last_call)/1000000.0;
	cout << "[tcp_sender] to '" << to_host << "(" << 
	  to_port << ")' bw " << bandwidth << " Mbit" << endl;
	last_call=t1;
	amount=0;
      }
    }
  return k;
}

TCP_Sender::~TCP_Sender()
{
  free(to_host);
  free(src_host);
  
  cout << "[tcp_sender] closed" << endl;
  close(sock);
}

double TCP_Sender::gettimeasdouble()
{
  struct timeval tv; 
  gettimeofday(&tv,NULL);
  return (double)tv.tv_sec+tv.tv_usec/1000000.0;
}

double TCP_Receiver::gettimeasdouble()
{
  struct timeval tv; 
  gettimeofday(&tv,NULL);
  return (double)tv.tv_sec+tv.tv_usec/1000000.0;
}

char *TCP_Receiver::version(){
  return TCP_VERSION;
}

TCP_Receiver::TCP_Receiver(unsigned short p, char *hn)
{
  cout << "[tcp_receiver] Version " << TCP_VERSION << endl;

  
  host=new char[256];

  if(!hn){
    gethostname(host,256);
  } 
  else {
    cout << "[tcp_receiver] setting host name" << endl;
    strcpy(host,hn);
  }
  port=p;
  
  output_interval=5;
  last_call=gettimeasdouble();
  bandwidth=0.0;
  
  //
  // Zieladresse
  //
  
  memset(&addr,0,sizeof(addr));
  hent=gethostbyname(host);
  memcpy(&addr.sin_addr, hent->h_addr, hent->h_length);
  addr.sin_port=htons(port);
  addr.sin_family=AF_INET;

  //
  // Socket oeffnen
  //
  
  sock=socket(AF_INET, SOCK_STREAM,0);
  if(sock<0) { 
    perror("[tcp_receiver] socket");
    exit(1);
  }

  if(bind(sock, (struct sockaddr*) &addr, sizeof(addr))!=0) {
    perror("[tcp_receiver] bind");
    exit(1);
  }
  
  if(listen(sock,1)<0){
    perror("[tcp_receiver] listen");
    exit(1);
  }
  if((socka=accept(sock, (struct sockaddr*) &daddr, 
		   (socklen_t*)&daddr_len))<0){
    perror("[tcp_receiver] accept");
    exit(1);
  }
  return;
}

TCP_Receiver::~TCP_Receiver()
{
  delete host;
  cout << "[tcp_receiver] closed" << endl;
  close(socka);
  close(sock); 
  return;
}

long TCP_Receiver::receivebuff(char *buffer, long l)
{
  long len;
  
  len=read(socka, buffer, 0xffff);
  
  if(output_interval){
    bandwidth+=len;
    double t1=gettimeasdouble();
    if(t1-last_call > output_interval) {
      bandwidth=8.0*bandwidth/(t1-last_call)/1000000.0;
      cout << "[tcp_receiver] to '" << host << "' bw " << 
	bandwidth << " Mbps " << endl;
      last_call=t1;
      bandwidth=0;
    }
  }
  return len;
}


