#include <iostream.h>
#include "udp_connection.H"
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/time.h>
#include <stdio.h>
#include <arpa/inet.h>

#define UDP_VERSION "0.04 alpha nofrag++"


char *UDP_Sender::version(){
  return UDP_VERSION;
}

UDP_Sender::UDP_Sender(unsigned long a, unsigned short b, unsigned long c, unsigned short d)
{
    cout << "[udp_sender] Version " << UDP_VERSION << endl;
    
    packetbuff=NULL;
    output_interval=5;
    bandwidth=0;
    droprate=0;
    last_call=gettimeasdouble();

    to_host=strdup(n2char(a));

    if(c!=0){
      src_host=strdup(n2char(c));
    }
    else {
      src_host=(char*)malloc(256);
      gethostname(src_host,256);
    }

    to_port=b;

    if(d!=0){
      src_port=d;
    } 
    else {
      src_port=b;
    }

    cout << src_host << " > " << to_host << endl;

    src_hent=gethostbyname(src_host);
    if(src_hent==NULL) {
      cerr << "[udp_sender] cannot get local hostname " << src_host << endl;
      return;}
    
    memset(&src_addr,0,sizeof(src_addr));
    memcpy(&src_addr.sin_addr, src_hent->h_addr, src_hent->h_length);
    src_addr.sin_port=htons(src_port);
    src_addr.sin_family=AF_INET;
    
    to_hent=gethostbyname(to_host);
    if(to_hent==NULL) {
      cerr << "[udp_sender] cannot get remote hostname " << to_host << endl;
      return;
    }
    
    memset(&to_addr,0,sizeof(to_addr));
    memcpy(&to_addr.sin_addr, to_hent->h_addr, to_hent->h_length);
    to_addr.sin_port=htons(to_port);
    to_addr.sin_family=AF_INET;
    
    sock=socket(AF_INET, SOCK_DGRAM,0);
    if(sock==-1) {
      perror("[udp_sender] unable tp open udp socket");
      return;
    }
    
    struct linger ling;
    ling.l_onoff=1;
    ling.l_linger=0;

    setsockopt(sock, SOL_SOCKET, SO_LINGER, &ling, sizeof(ling));
    
    if(bind(sock, (struct sockaddr*) &src_addr,sizeof(src_addr))!=0) {
      perror("[udp_sender] unable to bind socket");
      return;
    }
}

char* UDP_Sender::n2char(unsigned long l)
{
  struct in_addr in;
  in.s_addr=l;
  return inet_ntoa(in);
}

UDP_Sender::UDP_Sender(char *t, unsigned short tp, char *s, unsigned short sp) 
{
    cout << "[udp_sender] Version " << UDP_VERSION << endl;
    
    packetbuff=NULL;
    output_interval=5;
    bandwidth=0;
    droprate=0;
    last_call=gettimeasdouble();

    to_host=strdup(t);  

    if(s!=NULL){
      src_host=strdup(s);
    }
    else {
      src_host=(char*)malloc(256);
      gethostname(src_host,256);
    }

    to_port=tp;

    if(sp!=0){
      src_port=sp;
    } 
    else {
      sp=tp;
      src_port=tp;
    }

    cout << src_host << " > " << to_host << endl;

    src_hent=gethostbyname(src_host);
    if(src_hent==NULL) {
      cerr << "[udp_sender] cannot get local hostname " << src_host << endl;
      return;}
    
    memset(&src_addr,0,sizeof(src_addr));
    memcpy(&src_addr.sin_addr, src_hent->h_addr, src_hent->h_length);
    src_addr.sin_port=htons(src_port);
    src_addr.sin_family=AF_INET;
    
    to_hent=gethostbyname(to_host);
    if(to_hent==NULL) {
      cerr << "[udp_sender] cannot get remote hostname " << to_host << endl;
      return;
    }
    
    memset(&to_addr,0,sizeof(to_addr));
    memcpy(&to_addr.sin_addr, to_hent->h_addr, to_hent->h_length);
    to_addr.sin_port=htons(to_port);
    to_addr.sin_family=AF_INET;
    
    sock=socket(AF_INET, SOCK_DGRAM,0);
    if(sock==-1) {
      perror("[udp_sender] unable tp open udp socket");
      return;
    }
    
    struct linger ling;
    ling.l_onoff=1;
    ling.l_linger=0;

    setsockopt(sock, SOL_SOCKET, SO_LINGER, &ling, sizeof(ling));
    
    if(bind(sock, (struct sockaddr*) &src_addr,sizeof(src_addr))!=0) {
      perror("[udp_sender] unable to bind socket");
      return;
    }
}


int UDP_Sender::sendbuff(char *b, unsigned long l) {
    int k=0;
   
    if(droprate)if(((double)rand()/(RAND_MAX+1.0))<droprate)return l;
    
    k=sendto(sock, b, l, 0, (struct sockaddr*)&to_addr, sizeof(to_addr));
    
    if(output_interval)
      {
	amount+=l;
	double t1=gettimeasdouble();
	if(t1-last_call > output_interval) {
	  bandwidth=8.0*amount/(t1-last_call)/1000000.0;
	  cout << "[udp_sender] to '" << to_host << "(" << 
	    to_port << ")' bw " << bandwidth << " Mbit" << endl;
	  last_call=t1;
	  amount=0;
	}
      }
    if(k<0)k=0;
    return k;
}

UDP_Sender::~UDP_Sender()
{
  free(to_host);
  free(src_host);

  cout << "[udp_sender] closed" << endl;
  close(sock);
}


double UDP_Sender::gettimeasdouble()
{
    struct timeval tv; 
    gettimeofday(&tv,NULL);
    return (double)tv.tv_sec+tv.tv_usec/1000000.0;
}

double UDP_Receiver::gettimeasdouble()
{
    struct timeval tv; 
    gettimeofday(&tv,NULL);
    return (double)tv.tv_sec+tv.tv_usec/1000000.0;
}


char *UDP_Receiver::version(){
  return UDP_VERSION;
}


UDP_Receiver::UDP_Receiver(unsigned short p, char *h) 
{
    cout << "[udp_receiver] Version " << UDP_VERSION << endl;
    
    packetbuff=(char*)malloc(0xffff);
    output_interval=5;
 
    if(h){
      host=strdup(h);  
    } 
    else {
      host=(char*)malloc(256);
      gethostname(host,256);
    }

    port=p; 
    last_call=gettimeasdouble();
    bandwidth=0;
    
    hent=gethostbyname(host);
    if(hent==NULL) {
	cerr << "[udp_receiver] cannot get my hostname " << host << endl;
	exit(0);
    }
    memset(&addr,0,sizeof(addr));
    hent=gethostbyname(host);
    memcpy(&addr.sin_addr, hent->h_addr, hent->h_length);
    addr.sin_port=htons(port);
    addr.sin_family=AF_INET;
    
    sock=socket(AF_INET, SOCK_DGRAM,0);
    if(sock==-1) { cerr << "[udp_receiver] unable to socket" << endl; exit(1);}
    if(bind(sock, (struct sockaddr*) &addr, sizeof(addr))!=0) {
	cerr << "[udp_receiver] unable to bind" << endl; exit(1);
    }
    
    return;
}


UDP_Receiver::~UDP_Receiver()
{
  free(host);
  free(packetbuff);
  cout << "[udp_receiver] closed" << endl;
  close(sock);
  return;
}

long UDP_Receiver::receivebuff(char *buffer, long l)
{
    long len;
    
    len=read(sock, buffer, l);

    if(output_interval){
      bandwidth+=len;
      double t1=gettimeasdouble();
      if(t1-last_call > output_interval) {
	bandwidth=8.0*bandwidth/(t1-last_call)/1000000.0;
	cout << "[udp_receiver] to '" << host << "' bw " << 
	  bandwidth << " Mbit " << endl;
	last_call=t1;
	bandwidth=0;
      }
    }
    return len;
}


//
// splits host:port:host:port into single tokens
//

int split_destination(char *s, char *dhost, int *dport, char *shost, int *sport)
{

  int n;
  char *p;

  dhost[0]=0;
  *dport=0;
  if(sport)*sport=0;
  if(shost)shost[0]=0;


  for(p=s,n=0;;++n) {
    p=strchr(p,':');
    if(p==NULL)break;
    ++p;
  }

  if(n==1) {
    p=strchr(s,':'); *p='\0'; ++p;
    strcpy(dhost,s);
    *dport=atoi(p);
    return 1;
  }

  if(n==3) {
    p=strchr(s,':'); *p='\0'; ++p;
    strcpy(dhost,s);
    *dport=atoi(p);
    s=strchr(p,':'); *s='\0'; ++s;
    p=strchr(s,':'); *p='\0'; ++p;
    if(shost)strcpy(shost,s);
    if(sport)*sport=atoi(p);
    return 3;
  }

  return 0;
}
