#ifndef _udp_connection_h_
#define _udp_connection_h_

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include "senderreceiver.H"

unsigned short checksum(char *, int);

class UDP_Sender : public virtual Sender
{
 public:
  UDP_Sender(char *to_host, unsigned short to_port, 
	     char *src_host=NULL, unsigned short src_port=0);
  UDP_Sender(unsigned long to_hosta, unsigned short to_port, 
	     unsigned long src_hosta=0, unsigned short src_port=0);
  ~UDP_Sender();
  int sendbuff(char*, unsigned long);
  void set_droprate(double r){droprate=r;}
  void set_output_interval(double i)
    {
      output_interval=i;
    }
  char *version();
  int get_fh(){return sock;}

  unsigned long get_dest_addr(){
    return *(((unsigned long**)to_hent->h_addr_list)[0]);
  }
  
  unsigned short get_dest_port(){
    return to_port;
  }
 
 private:
  char* n2char(unsigned long l);
  char *packetbuff;
  unsigned long amount;
  int sock;
  double output_interval;
  double gettimeasdouble();
  double bandwidth;
  struct sockaddr_in src_addr, to_addr;
  struct hostent *src_hent, *to_hent;
  char *to_host, *src_host;
  unsigned short to_port, src_port;
  double last_call;
  double droprate;

};



class UDP_Receiver : public virtual Receiver 
{
 public:
  UDP_Receiver(unsigned short port, char *host=NULL);
  ~UDP_Receiver();
  long int receivebuff(char *, long int);
  void set_output_interval(double i){output_interval=i;}
  char *version();
  int get_fh(){return sock;}

  unsigned short get_port(){
    return port;
  }

 private:
  char *packetbuff;
  int sock;
  double output_interval;
  double gettimeasdouble();
  double bandwidth;
  struct sockaddr_in addr;
  struct hostent *hent;
  char *host;
  unsigned short port;
  double last_call;
};


// some toolkitfunctions

// split destination like sancho.unibe.ch:5000:5000 into parts

int split_destination(char *s, char *dhost, int *dport, char *shost, int *sport);
  

#endif

