#ifndef _softlink_h_
#define _softlink_h_

// #define DEBUG         1 
#define NOF           8
#define DEVICE_MAJOR 63


#define TX_INTR 1
#define RX_INTR 2

struct nt_priv{
  int len_r;
  int status;
  char *buff_r;  /* buffer for data net -> dev */
  int len_w;
  char *buff_w;  /* buffer for data dev -> net */
  struct wait_queue *inq, *outq;
  struct enet_statistics stats;
};

struct ch_priv{
  unsigned int minor;
  unsigned int major;
};


static void nt_interrupt(int irq, void *dev_id, struct pt_regs * regs);

static unsigned int ch_poll(struct file *fi, poll_table *wait);
static int     ch_open(struct inode *in, struct file *f);
static ssize_t ch_read(struct file *f, char *d, size_t s, loff_t *l);
static ssize_t ch_write(struct file *f, const char *d, size_t s, loff_t *l);
static int     ch_release(struct inode *inode, struct file *file);

static int nt_open(struct device *dev);
static int nt_stop(struct device *dev);
static int nt_set_config(struct device *dev, struct ifmap *map);
static int nt_tx(struct sk_buff *skb, struct device *dev);
static void nt_rx(struct device *dev, int len, unsigned char *buf);
static int nt_ioctl(struct device *dev, struct ifreq *ifr, int cmd); 
struct enet_statistics *nt_stats(struct device *dev);
static int nt_rebuild_header(struct sk_buff *skb);
static int nt_init(struct device *dev);
static int ch_ioctl(struct inode *, struct file *, unsigned int , unsigned long );


#endif
