#ifndef _Defragmenter_h
#define _Defragmenter_h_

#include "packet.H"

#define DFRG_HASHTABLE_SIZE 256

///
struct DFRG_FRAG_S{ 
  ///
  Packet data[80];                  /// 80 * 20 = 1600 Byte 
  struct DFRG_FRAG_S *next_frag;
};

typedef struct DFRG_FRAG_S DFRG_FRAG;

struct DFRG_PKT_S{
  ///
  double last_access;
  ///
  unsigned long fraglen;
  ///
  unsigned long datalen;
  ///
  unsigned long source;
  ///
  unsigned short id;
  ///
  unsigned short fragcnt;
  ///
  DFRG_FRAG *first_frag;
  ///
  DFRG_FRAG *last_frag;
  ///
  struct DFRG_PKT_S *next_pkt;
};

typedef struct DFRG_PKT_S DFRG_PKT;

typedef struct{
  ///
  DFRG_PKT *last_pkt;
  ///
  DFRG_PKT *pkt;
  ///
  unsigned short pktcnt;
} ///
 DFRG_HASHTE;

///
class Defragmenter
{
public:
  ///
  Defragmenter();
  ///
  ~Defragmenter();
  ///
  PSPacket *defragment(Packet*);
  
private:
  ///

  unsigned short hash(Packet *);
  ///
  int free_fragchain(DFRG_FRAG *first, DFRG_FRAG *last, int);
  ///
  int free_frag(DFRG_FRAG *);
  ///
  DFRG_FRAG *alloc_frag();
  ///
  int add_frag_to_fragchain(DFRG_PKT*, Packet*); 
  ///
  int concat_frags(DFRG_PKT*);

  ///
  int free_frags;
  ///
  int alloc_frags;
  ///
  int alloc_pkts;
  
  ///
  PSPacket *outbuff;
  ///
  DFRG_HASHTE *ht;
  ///
  DFRG_FRAG *freefrag_first;

}///
;



#endif
