#include <string.h>
#include "tools.H"
#include "packet.H"
#include "ffilter.H"

FFilter::FFilter()
{
  source_ip=0;   
  source_nm=0xffffffff;
  dest_ip=0; 
  dest_nm=0xffffffff;
  mode=FFILTER_MODE_COPY;
  proto=0;
  prio=1000;
  tos=0;
  ipopt_type=0;
  ipopt_value=0;
  flags=0;
  memset(name,0,16);
  return;
}

int FFilter::equals(FFilter *f)
{
  return !bcmp(this,f,sizeof(FFilter));
}

int FFilter::matches(Packet *p)
{
  if(dest_ip){
    if((PKT_DEST(p)&dest_nm) != (dest_ip&dest_nm))return 0;
  }
  if(source_ip){
    if((PKT_SOURCE(p)&source_ip) != (source_ip&source_nm))return 0;
  }
  if(proto!=0xffff){
    if(proto!=PKT_PROTO(p))return 0;
  }
  if(tos!=0xffff){
    if(tos!=PKT_TOS(p))return 0;
  }

  //
  // check for ipopt type

  if(ipopt_type){
    if(PKT_IHL(p)==5)return 0;

    char *c=(char*)p+20, *cmax=(char*)p+PKT_IHL(p)*4;

    for(;IPOPT_NUMBER(*c)!=IPOPT_END && c<cmax;){
      
      if(IPOPT_NUMBER(*c)==ipopt_type&0xff)return 1;
      
      switch(IPOPT_NUMBER(*c))
        {
        case IPOPT_NOOP: 
	  c++;
          break;
        case IPOPT_SEC: 
          c+=11; 
	  break;
        case IPOPT_SID:
          c+=4; 
	  break;
        default:
	  c+=*(c+1)&0xff;
        }
    }
  }
  
  return 1;
}

