#ifndef _pfilter_h_
#define _pfilter_h_

#include "packet.H"
#include "api.H"

#define MAX_PARALLEL_DFRG_PKTS 16
#define FFILTER_FLAG_DELETE  1


class VR;
class ForwarderIF;
class ProtocolStack;
class RawSock;
class FFilter;

class Forwarder : public virtual VRschedObj
{
  friend Sock;
public:
  Forwarder(VR*, int n=256);
  ~Forwarder();
  char *id(){return "forw";}
  int add(FFilter*);
  int del(FFilter*);
  FFilter *lookup(Packet*);
  unsigned short distribute(Interface *, Packet*);
  int get_num_of_filters(){return num_of_filters;}
  int get_packet_id(){return ++packet_id;}
  int interrupt(VRevent *);
  int send_packet(char*,int);
  VRRB* APIconfigure(API *, VRCB *);
  RawSock *raw_socks;
  UDPSock *udp_socks;

private:
  int hostif[2];
  int packet_id;
  Defragmenter *dfrg;
  VR *vr;
  int maintainance();
  int sort();
  int num_of_filters;
  int last;
  int size_of_table;
  ProtocolStack *host_protocols[256];
  FFilter **table; 
  VRevent *event;
};




#endif








