#ifndef _interface_h_
#define _interface_h_

#include <intercon/udp_connection.H>
#include "api.H"
#include "vr.H"
#include "vrsched.H"

class VRCP;
class VRRB;
class ForwarderIF;
class VRevent;
class Packet;

class Interface : public virtual VRschedObj
{
public:
  Interface(VR*, char *ip, char *nm, char *name);
  Interface(VR*, unsigned long ip, unsigned long nm, unsigned long bc,  char *name);
  ~Interface();
  int DisConnect();
  int ConnectToSoftlink(unsigned short);
  int ConnectToFIFO(unsigned short, unsigned short);
  int ConnectToUDP(unsigned long to, unsigned short tx_port, 
		   unsigned short rx_port);

  int Setup_IPIPtunnel(unsigned long dest_addr, unsigned long mtu);
  int ipip_encap(Packet *p);

  char *id(){return idstring;}
  VRRB* APIconfigure(VRCB *in);
  void send_packet(Packet *p);
  int interrupt(VRevent *e);
  unsigned long get_ip(){return ip;}
  int set_forwarder(ForwarderIF*);
  int del_forwarder();
  int API_fill_info_rb(IF_INFORMATION_RB*);

private:
  char last_in_buffer[128];
  char last_out_buffer[128];

  enum {disconnected, softlink, local, tunnel, ipiptunnel}  connectiontype;
  unsigned short cable_no;
  unsigned short cable_end;
  ForwarderIF *forwarder;
  VR* vr;
  void constructor_common();
  VRevent *event;
  char *idstring;
  unsigned long ip, nm, bc;
  int fh_r, fh_w;
  UDP_Sender   *sender;
  UDP_Receiver *receiver;
  QCroot *q_send;
  Packet *packet_in;
  unsigned long tx_stat, rx_stat, err_stat, drop_stat;
  unsigned short packet_ids;

  // ip translaation
  int iptrans_enable;
  unsigned long iptrans_rx_ip;
  unsigned long iptrans_rx_nm;
  unsigned long iptrans_rx_value;
  unsigned long iptrans_rx_pattern;
  unsigned long iptrans_tx_ip;
  unsigned long iptrans_tx_nm;
  unsigned long iptrans_tx_value;
  unsigned long  iptrans_tx_pattern;
  
  // bandwidth delimiter

  double last_call;
  unsigned long bandwidth;   //- in bytes per sec
  unsigned long bucketsize;  //- in bytes
  unsigned long bucket_write;
  unsigned long bucket_read;

  // IPIP tunnel paraeters

  unsigned short packet_id;
  unsigned long ipip_mtu;
  unsigned long ipip_destination;
};

#endif
