#ifndef _ipnmx_h_
#define _ipnmx_h_

#include "vr.H"
#include "packet.H"

class IPNMxRecord
{
public:
  IPNMxRecord(unsigned long sip, unsigned long snm, 
	      unsigned long dip, unsigned long dnm,
	      unsigned short p, unsigned short t, void *v);
  IPNMxRecord(char *d, char *s, int p, int t, void *v);
  IPNMxRecord(unsigned long ip, unsigned long nm, void *v);
  IPNMxRecord(Packet *);
  IPNMxRecord();
  ~IPNMxRecord();

  int set(char *d, char *s, int p, int t, void *v);
  int set(IPNMxRecord);

  bool equals(IPNMxRecord*);
  bool gt(IPNMxRecord*);
  bool lt(IPNMxRecord*);
  int hits(Packet*);
  void clear();
  void init();


  unsigned long  sip_add;  /// source
  unsigned long  snm_add; 
  int snm_num;
  unsigned long  dip_add;  /// dest
  unsigned long  dnm_add;
  int dnm_num;
  unsigned short proto;		// set to 0xffff to ignore
  unsigned char  tos;		// set to 0xffff to ignore
  void *content;
};

class IPNMx 
{
public:
  IPNMx(int n=0xffff);
  ~IPNMx();
  int add(IPNMxRecord&); 
  int del(IPNMxRecord&);
  void list();
  int get_first(IPNMxRecord &);
  int get_next(IPNMxRecord &);
  int size(){return nof_entries;}

  IPNMxRecord* lookup(Packet*);
  IPNMxRecord **table;
  int nof_allocated;
  int nof_entries;
  void cleanup();
  void sort();
private:
  int list_counter;
};

#endif





