#ifndef _lob_h_
#define _lob_h_

#include "vrsched.H"

#define LOBSTART(A)  extern "C"{LOB *lob_start(LOBenv *e){return new (A)(e);}}

// error code for load_object

#define LOB_LOAD_OKAY  0
#define LOB_LOAD_EXEED 1
#define LOB_LOAD_OPEN  2
#define LOB_LOAD_SYM   3

// result codes for the lob run method

#define LOB_TERMINATE          0 // can be deleted 
#define LOB_TERMINATE_AND_STAY 1 // code stays resident

// flags for the mode member in a lob

#define LOB_MODE_RUN	1	// execute the run method
#define LOB_MODE_THREAD 2	// thread and execute the run method
#define LOB_MODE_STAY   4	// do not delete object 


//> LOB
class LOB
{
  friend void* lob_run(LOBenv*);
  friend class VRsched;

public:
  LOB(LOBenv *);		//- the constructor with a pointer to the
				//- environment 
  virtual ~LOB();		//- the desctructor

protected:
  virtual int run(){return LOB_TERMINATE;}
  LOBenv *env;			//- environment class
};
//<


#endif
