#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "qco.H"
#include "qcroot.H"
#include "tools.H"
#include "packet.H"

QCO::QCO(QCroot *q)
{
  qr=q;
  vr=qr->vr;
  ins=NULL;
  outs=NULL;
  nof_ins=0;
  max_nof_ins=0;
  nof_outs=0;
  max_nof_outs=0;
  return;
}

// return the component id 
// 
int QCO::get_id(QCO* q)
{
  for(int i=0;i<qr->nof_qcos;++i){
    if(q==qr->qcos[i])return i;
  }
  return -1;
}

// drop a packet 
//
int QCO::drop(Packet *p)
{
  if(p==NULL) fhprintf(vr->cfh,"PANIC: drop of null Packet!!\n");
  ++qr->packets_dropped;
  qr->packets_in_qs--;
  qr->qcmem->release(p);
  return 0;
}


// returns true of flase dependent, whether
// a component is still in use
//
bool QCO::isusing(QCO *q)
{
  int i;
  if(ins){
    for(i=0;i<nof_ins;++i){
      if(ins[i]==q) return 1;
    }
  }
  if(outs){
    for(i=0;i<nof_outs;++i){
      if(outs[i]==q) return 1;
    }
  }
  return 0;
}

int QCO::unnext(QCO *q)
{
  int i;
  if(outs==NULL)return 0;
  for(i=0;i<nof_outs;++i){
    if(outs[i]==q){
      outs[i]=NULL; // new
      break;
    }
  }
  if(i>=nof_outs)return 1;
  
  for(;i<nof_outs-1;++i){
    outs[i]=outs[i+1];
  }
  outs[i]=NULL; // new
  --nof_outs;
  return 0;
}


int QCO::unprev(QCO *q)
{
  int i;
  if(ins==NULL)return 0;
  for(i=0;i<nof_ins;++i){
    if(ins[i]==q){
      ins[i]=NULL; // new
      break;
    }
  }
  if(i>=nof_ins)return 1;
  
  for(;i<nof_ins-1;++i){
    ins[i]=ins[i+1];
  }
  ins[i]=NULL;  // new
  --nof_ins;
  return 0;
}


int QCO::next(QCO* q)
{
  if(outs==NULL){
    return 1;
  }
  if(nof_outs>=max_nof_outs)return 1;
  outs[nof_outs++]=q;
  return 0;
}

int QCO::prev(QCO* q)
{
  if(ins==NULL)return 1;
  if(nof_ins>=max_nof_ins)return 1;
  ins[nof_ins++]=q;
  return 0;
}





