#ifndef _qcroot_h_
#define _qcroot_h_

#include "vr.H"
#include "qco.H"
#include "qcmem.H"


class QCroot : public QCO
{
  friend class QCO;

public:

  QCroot(VR*);
  ~QCroot();
  
  char *id(){return "root";}
  unsigned short int type_id(){return 0;}
  
  VRRB* APIconfigure(VRCB *in);
  //  int configure(CON*, int, char **);

  Packet *root_deque();
  Packet *root_nextdeque();
  
  int root_enque(Packet *);

  unsigned long get_packets_in_qs(){return packets_in_qs;}

  
private:
  Packet *deque(QCO *);
  int enque(Packet *);

  //  int chain(CON*, int, int);
  // int unchain(CON*, int, int);
  void clearstats();
  unsigned long enques;
  unsigned long deques;
  unsigned long drops;
  Packet *deque_buffer;
  int *flags;
  // void status(CON*);
  // int erase(CON*, int);
  // int create(CON*, char*);
  // int list(CON*);
  QCmem *qcmem;
  QCO** qcos;
  int nof_qcos, max_nof_qcos;
  unsigned long packets_dropped;

  unsigned long packets_in_qs; // number of packets stored in this qs

};

#endif


