#ifndef _qctrio_h_
#define _qctrio_h_

#include "qco.H"

class QCtrio : public QCO
{
public:
  QCtrio(QCroot*, int n=8192);
  ~QCtrio();

  char *id(){return "trio";}
  unsigned short int type_id(){return QCTYPEID_TRIO;}
  Packet * deque(QCO *);
  Packet * nextdeque(QCO*);
  int enque(Packet *p);
  int can_enque(Packet *);
  VRRB* APIconfigure(VRCB *);

private: 
  int resize(int);
  unsigned short queuelen[3];
  unsigned long dropped_packets[3];

  unsigned long deempty;
  unsigned long dehits;
  unsigned long dereq;
  int mode;
  int nof_pkts; 
  int max_nof_pkts;
  int en_idx;
  int de_idx;
  Packet **pkts;
};


#endif
