#ifndef _udp_h_
#define _udp_h_

#define UDP_OKAY   0
#define UDP_NOPORT 1
#define UDP_BUSY   2

///
class VR;
class IOC;
class UDP;

#include "config.H"
#include "forwarder.H"
#include "ioc.H"

typedef struct{
  int port_no;
  int busy;
  int block;
  UDP *ch;
} UDPPORT;

typedef struct{
  unsigned short sp;
  unsigned short dp;
  unsigned short len;
  unsigned short crc;
} UDPPacket;

#define UDP_LENGTH(P)  ( ntohs((P)->len) )
#define UDP_DPORT(P)   ( ntohs((P)->dp) )
#define UDP_SPORT(P)   ( ntohs((P)->dp) )
#define UDP_CRC(P)     ( ntohs((P)->crc) )
#define UDP_DATA(P)    ( ((char*)(P)) + 8 )


class UDPstack: public virtual ProtocolStack
{
  friend class UDP;
public:
  UDPstack(VR *);
  ~UDPstack();
  int process(PSPacket*);
    
private:
  int alloc_ports;
  int free_udp_port(int);
  int alloc_udp_port(int, UDP* );
  UDPPORT *query_udp_port(int);

  UDPPORT udp_ports[MAX_OPEN_UDPPORTS];

  VR *vr;
};


class UDP : public IOchannel
{
public:
  UDP(VR*, int);
  ~UDP();
  int status(){return up;}
  int port(){return up;}

private:
  int up;
  UDPstack *us;
  VR *vr;
};

#endif
